use test
go
if object_id('SimpleTable') is not null	
	drop table SimpleTable
create table SimpleTable(id int primary key, text1 varchar(8000))
go
insert into SimpleTable 
	values	(100, replicate('a',2800)),
			(200, replicate('b',2800)),
			(300, replicate('c',2800)),
			(400, replicate('d',2800))


--demo1
--session 1
begin transaction
update SimpleTable set text1='a' where id = 100

update SimpleTable set text1 = 'b' where id = 400
rollback
--
--session 2
begin transaction
update SimpleTable set text1='a' where id = 400

update SimpleTable set text1 = 'b' where id = 100
rollback

--demo 2
if object_id('Customer') is not null
	drop table Customer
if object_id('Invoice') is not null
	drop table Invoice
go
create table Customer(
	CustomerID int IDENTITY(1,1) NOT NULL primary key,
	CustomerName varchar(30) NULL,
	Address1 varchar(50) NULL,
	Address2 varchar(50) NULL,
) 
go
create table Invoice(
	InvID int IDENTITY(1,1) NOT NULL primary key,
	InvDate datetime NULL,
	CustomerID int NULL,
	Amount numeric(9, 2) NULL,
)
go
alter table Invoice add constraint FK_Customer foreign key(CustomerID) references Customer(CustomerID)
create index IX_Invoice_Customer on Invoice(CustomerID)
go

insert into Customer (CustomerName,address1,address2) values ('Customer 1','Address 11','Address 21')
insert into Customer (CustomerName,address1,address2) values ('Customer 2','Address 12','Address 22')
insert into Customer (CustomerName,address1,address2) values ('Customer 3','Address 13','Address 23')
insert into Customer (CustomerName,address1,address2) values ('Customer 4','Address 14','Address 24')
insert into Customer (CustomerName,address1,address2) values ('Customer 5','Address 15','Address 25')
	
	
insert into Invoice (InvDate, CustomerID, amount) values (getdate(), 1, 1000)
insert into Invoice (InvDate, CustomerID, amount) values (getdate(), 2, 2000)
insert into Invoice (InvDate, CustomerID, amount) values (getdate(), 3, 3000)
insert into Invoice (InvDate, CustomerID, amount) values (getdate(), 4, 4000)
insert into Invoice (InvDate, CustomerID, amount) values (getdate(), 5, 5000)
select * from Customer
select * from Invoice
---session1
begin tran
update Customer set CustomerName = 'Customer Change1' where CustomerID = 1
update Invoice set Amount = Amount - 30 where CustomerID = 1
--rollback
--session 2
begin tran
update Invoice set CustomerID = 1 where invid = 3
--rollback


rollback
