use test
go
if object_id('SimpleTable') is not null	
	drop table SimpleTable
create table SimpleTable(id int, text1 varchar(8000))
go
insert into SimpleTable values(100, replicate('a',2800)),(200, replicate('b',2800)),(300, replicate('c',2800)),(400, replicate('d',2800))
--select * from SimpleTable
--4 records inserted. it needs 2 data pages
go

set transaction isolation level read uncommitted
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
select * from SimpleTable where id = 300
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
go
exec ShowEvents
go

select object_name(object_id),* from sys.partitions where partition_id = 72057594039697408

set transaction isolation level read committed
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
select * from SimpleTable where id = 300
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
go
exec ShowEvents
-- does not have any locks on the row, why?
go

use master
alter database test set read_committed_snapshot on with rollback immediate
use test
go
set transaction isolation level read committed
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
select * from SimpleTable where id = 300
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
go
exec ShowEvents
go

set transaction isolation level read committed
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
select * from SimpleTable with (readcommittedlock) where id = 300
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
go
exec ShowEvents
go

use master
alter database test set read_committed_snapshot off 
use test
go
exec ShowPages
set transaction isolation level repeatable read
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
select * from SimpleTable  where id = 300
rollback
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
go
exec ShowEvents


set transaction isolation level serializable
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
select * from SimpleTable  where id = 300
rollback
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
go
exec ShowEvents

go

if object_id('SimpleTable') is not null	
	drop table SimpleTable
create table SimpleTable(id int primary key, text1 varchar(8000))
go
insert into SimpleTable values(100, replicate('a',2800)),(200, replicate('b',2800)),(300, replicate('c',2800)),(400, replicate('d',2800))
go

set transaction isolation level serializable
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
select * from SimpleTable  where id = 300
rollback
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
go
exec ShowEvents


go

if object_id('SimpleTable') is not null	
	drop table SimpleTable
create table SimpleTable(id int, text1 varchar(8000))
create clustered index ID on SimpleTable(id)
go
insert into SimpleTable values(100, replicate('a',2800)),(200, replicate('b',2800)),(300, replicate('c',2800)),(400, replicate('d',2800))
go

set transaction isolation level serializable
exec xp_cmdshell N'del c:\temp\locktest00*.*' ,no_output
ALTER EVENT SESSION locks ON SERVER STATE = START
go
begin transaction
select * from SimpleTable  where id = 300
--insert into SimpleTable values(399, 'a')
rollback
go
ALTER EVENT SESSION locks ON SERVER STATE = STOP
go
exec ShowEvents
go

--set transaction isolation level read committed